# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to the versioning of Factorio, so 0.18.x will be at least compatible / tested with Factorio 0.18.x.

## [Released]

## [0.18.2] - 2020-06-06
Based on user feedback updated the mod
### Added
- new easter egg :-)
- added more math.lib functions
  - atan2() -> math.atan2()
  - cosh() -> math.cosh()
  - sinh() -> math.sinh()
  - tanh() -> math.tanh()
  - log10() -> math.log10()
  - fmod() -> math.fmod()
  - frexp() -> math.frexp()
  - ldexp() -> math.ldexp()
  - pow() -> math.pow()

### Fixed
- Interpreting ";" as "," in the equation, because of the fix in 0.18.1, so that math functions with more than 1 parameter work. They have to use ";" as a separator for inputs
- Fixed sqrt(-1) equaling "na" because of the rounding fix from 0.18.1. It does now show "NaN" again

## [0.18.1] - 2020-06-06
Based on user feedback updated the mod
### Added
- Shortcut for opening the calculator and automatically focus on the input (Default: Ctrl+Shift+C) 

### Fixed
- Rounding removed 0 at the end, will now stand as it should. So 2.0000001 -> 2.00
- Interpreting "," as "." in the equation, because of some European countries do have a weird keyboard layout

## [0.18.0] - 2020-06-06
### General
- Initial Release of the mod 
- Compatible with Factorio >0.18.0; tested on 0.18.30
- Based on the 4-Function Calculator found in the [Max Rate Calculator](https://mods.factorio.com/mod/MaxRateCalculator) mod by [Theanderblast](https://mods.factorio.com/user/theanderblast)

### Added
- History of recent calculations
- Possibility to copy recent calculations to the current one (with shift+left-click)
- Substitutes some functions & "constants" of the Lua [math-lib](http://lua-users.org/wiki/MathLibraryTutorial)
  - abs() -> math.abs()
  - acos() -> math.acos()
  - asin() -> math.asin()
  - atan() -> math.atan()
  - ceil() -> math.ceil()
  - floor() -> math.floor()
  - cos() -> math.cos()
  - sin() -> math.sin()
  - tan() -> math.tan()
  - deg() -> math.deg()
  - rad() -> math.rad()
  - exp() -> math.exp()
  - log() -> math.log()
  - min() -> math.min()
  - max() -> math.max()
  - modf() -> math.modf()
  - sqrt() -> math.sqrt()
  - huge -> math.huge
  - pi -> math.pi
- Allows the use of "%" (percent sign) in the calculation
- A little easter egg :-)
- Setting for number of decimal places in result (Default: 2). Exact value will be displayed in the tooltip
- Setting if triggering the calculation should clear the current equation (Default: no)

### Changed
- Made the buttons slightly bigger, so that it's better readable on streams.
- Allows to make "complex" calculations with parentheses
- Allows pretty much all characters in the equation field
  - but the "=" (equal sign) will trigger the calculation

### Removed
- Got rid of the memory functions - but introduced the list of recent calculations instead